;; 1.- Patrones y variables

;; Todos los planetas
(is-planeet ?p)

;; Lunas de Júpiter
(is-moon-of ?moon Jupiter)

;; Lunas que descubrió Galileo
(was-discovered ?moon ?date Galilei)

;; Quién descubrió Deimos?
(was-discovered Deimos ?date ?person)

;; Diametro de marte
(has-diameter Mars ?diameter)


;; 2.- Consultas compuestas (and, or)

;; De qué planeta es luna Deimos? Cuál es la distancia al Sol de este planeta
(and (is-moon-of Deimos ?planet) (has-distance-to-sun ?planet ?distance))

;; Distancia al sol, tiempo de rotación y masa de Urano
(and (has-distance-to-sun Uranus ?distance)
     (has-rotationtime Uranus ?direction ?rtime)
     (has-mass Uranus ?mass))

;; 3.- Filtros (not, lisp-value)


;; Planetas sin lunas
(and (is-planet ?p)
     (not (is-moon-of ?moon ?p)))

;; Planetas más pequeños que la tierra
(and (is-planet ?p)
     (has-diameter ?p ?diameter)
     (has-diameter Earth ?e-diameter)
     (lisp-value < ?diameter ?e-diameter))

;; Planeta con masa más grande
(and (is-planet ?p)
     (has-mass ?p ?m)
     (not (and (is-planet ?p2)
               (has-mass ?p2 ?m2)
               (lisp-value > ?m2 ?m))))

;; Objetos más pequeños en la DB
(and (or (is-planet ?object)
         (is-moon-of ?object ?planet))
     (has-mass ?object ?m)
     (not (and (or (is-planet ?object2)
                   (is-planet ?object2 ?planet2))
               (has-mass ?object2 ?m2)
               (lisp-value < ?m2 ?m))))

;; 3.- Reglas

;; Es luna?
(assert! (rule (is-moon ?x)
               (is-moon-of ?x ?p)))

;; Más pequeño?
(assert! (rule (smaller ?x ?y)
               (and (is-planet ?x)
                    (is-planet ?y)
                    (has-diameter ?x ?m)
                    (has-diameter ?y ?m)
                    (lisp-value < ?m ?n))))